import java.util.ArrayList;

/**
 * This class contains methods for working with while loops and Die instances.
 * 
 * @author Brad Richards
 */
public class LoopPractice
{
    /**
     * This method rolls a Die the specified number of times, printing each
     * of the rolled values as it goes.
     * @param d  The Die to be rolled
     * @param numRolls  The desired number of rolls
     */
    public void rollNTimes(Die d, int numRolls)
    {
        int counter = 0;
        int rolledValue;
        while (counter < numRolls) {
            rolledValue = d.roll();
            System.out.print(rolledValue+" ");  // Use print and a space so they stay on one line
        }
        System.out.println();   // Now move down to the next line to be polite
    }
    
    /**
     * This method rolls a Die the specified number of times, then calculates
     * and returns the average of the rolled values.  
     * @param d  The Die to be rolled
     * @param numRolls  The number of rolls to average
     * @return The average of the rolled values
     */
    public double averageRoll(Die d, int numRolls) 
    {
        return 0.0;     // Replace this line with your own code
    }
    
    /**
     * This method rolls a Die the specified number of times, keeping track
     * of the largest and smallest values rolled, and printing them after
     * making all of the rolls.
     * @param d  The Die to be rolled
     * @param numRolls  The number of rolls to perform
     */
    public void findMinAndMax(Die d, int numRolls)
    {
        // Your code goes here
    }
    
    /**
     * This method rolls a Die until the largest and smallest possible values
     * have been rolled.  It counts the number of rolls required and prints 
     * it once the extreme values have both been rolled.
     * @param d  The Die to be rolled
     */
    public void rollUntilExtremesFound(Die d) 
    {
        // Feel free to replace this with your own code if you prefer.
        // I found it useful to keep a pair of boolean variables to track progress.
        
        boolean rolledMin = false;  // Have we rolled a 1 yet?
        boolean rolledMax = false;  // Have we rolled the max value yet?
        
        // More code goes here
    }
    
    /**
     * This method rolls a Die until *all* possible values have been rolled.
     * @param d  The Die to be rolled
     */
    public void rollUntilAllValuesFound(Die d)
    {
        ArrayList<Integer> rolledValues;    // Keep track of the values rolled so far
        
        // More code goes here.
    }
    
    /**
     * Rolls a Die until the difference between two successive rolls is the value
     * specified by the user.  When that condition is met, the method prints the
     * two values for the user.
     * @param d  The Die to be rolled
     * @param diff  The desired difference between successive rolls
     */
    public void rollUntilDifference(Die d, int diff) 
    {
        int lastRoll = d.roll();        // This variable holds the "oldest" roll
        int currentRoll = d.roll();     // This holds the most recent roll
        
        // More code goes here
    }
}
